#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "globals.h"
#include "helpers.h"

void
on_tbtPrefs_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *wnd;
	if ( AppCfg.flags & FLAG_SHOWPREFS )
		return;
	wnd = create_wndPrefs();
	gtk_widget_show_all(wnd);
}

void
on_btSend_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
	//on_btSend_clicked_test(button, user_data);
	GtkWidget *msg = lookup_widget(GTK_WIDGET(button), "tvMsg");
	GtkWidget *contact = lookup_widget(GTK_WIDGET(button), "ceContact");
	GtkWidget *server = lookup_widget(GTK_WIDGET(button), "ceServer");
	gchar *pMsg, *pContact, *pServer;

	pMsg = nt_textview_get_text(msg);
	pContact = (gchar *)gtk_entry_get_text(GTK_ENTRY(contact));
	pServer = (gchar *)gtk_entry_get_text(GTK_ENTRY(server));
	
	nt_run_command(pMsg, pContact, pServer);
	
	g_free(pMsg);
}


void
on_tbtAbout_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *wnd;

	if ( AppCfg.flags & FLAG_SHOWABOUT )
		return;

	wnd = create_wndAbout();
	gtk_widget_show_all(wnd);
}



void
on_app1_show                           (GtkWidget       *widget,
                                        gpointer         user_data)
{
	GtkWidget *cbServer = lookup_widget(GTK_WIDGET(widget), "cbServer");
	GtkWidget *cbContact = lookup_widget(GTK_WIDGET(widget), "cbContact");
	nt_fill_cbServer(cbServer);
	nt_fill_cbContact(cbContact);
}


void
on_tbtAddrBook_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *wnd;
	if ( AppCfg.flags & FLAG_SHOWADDRBOOK )
		return;
	wnd = create_wndAddrBook();
	gtk_widget_show_all(wnd);
}


void
on_tbtServers_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *wnd;
	
	if ( AppCfg.flags & FLAG_SHOWSERVERS )
		return;
	wnd = create_wndServers();
	gtk_widget_show_all(wnd);

}





void
on_wndAbout_show                       (GtkWidget       *widget,
                                        gpointer         user_data)
{
	AppCfg.flags |= FLAG_SHOWABOUT;
}


void
on_wndAbout_destroy                    (GtkObject       *object,
                                        gpointer         user_data)
{
	AppCfg.flags &= ~FLAG_SHOWABOUT;
}





