#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <stdlib.h>

#include "interface.h"
#include "support.h"
#include "helpers.h"

/* Searches in ~/.linuxsms/password 
 * for configured servers
 */

GLSPrefs AppCfg;
/* TODO: is this really necessary??? */
char nt_cfg_servers[MAX_CFGSERVERS][MAX_CFGSERVER_LEN];
char nt_cfg_contacts[MAX_CFGCONTACTS][MAX_CFGCONTACT_LEN];

int nt_fill_defaults()
{
  char *p;
//  char p[] = { "/home/nmct" };
  AppCfg.flags = 0;
  AppCfg.status = STATUS_READY;
  if ( !(p = getenv("HOME")) )
  	return 1;
  sprintf(AppCfg.file_passwd, "%s/.linuxsms/password", p);
  sprintf(AppCfg.file_addrbook, "%s/.linuxsms/addressbook", p);
  sprintf(AppCfg.file_conf, "%s/.linuxsms/linuxsmsrc", p);
  sprintf(AppCfg.file_bin, "%s/bin/sms", p);
  return 0;
}


int nt_fill_cbServer(GtkWidget *cmbbox) 
{
  FILE *fp = fopen(AppCfg.file_passwd, "rt");
  char buf[MAX_CFGLINE_LEN], *p, *q;
  GList *items = NULL;
  int i = 0;
  
  if ( !fp )
  	return 1;
  
  while (fgets(buf, MAX_CFGLINE_LEN, fp)) {
  	p = buf;
  	while ((*p) && ((*p==' ') || (*p=='\n')))
  		p++;
  	if ( *p != '#' ) {
  		q = strchr(p, ':');
  		if ( q ) {
  			*q = '\0';
	  		strcpy(nt_cfg_servers[i], p);
  			items = g_list_append(items, nt_cfg_servers[i++]);
  		}
  	}
  }
  fclose(fp);
  
  gtk_combo_set_popdown_strings(GTK_COMBO(cmbbox), items);
}


int nt_fill_cbContact(GtkWidget *cmbbox) 
{
  FILE *fp = fopen(AppCfg.file_addrbook, "rt");
  char buf[MAX_CFGLINE_LEN], *p, *q;
  GList *items = NULL;
  int i = 0;
  
  if ( !fp )
  	return 1;
  
  while (fgets(buf, MAX_CFGLINE_LEN, fp)) {
  	p = buf;
  	while ((*p) && ((*p==' ') || (*p=='\n')))
  		p++;
  	if ( *p != '#' ) {
  		q = strchr(p, ':');
  		if ( q ) {
  			*q = '\0';
	  		strcpy(nt_cfg_contacts[i], p);
  			items = g_list_append(items, nt_cfg_contacts[i++]);
  		}
  	}
  }
  fclose(fp);
  
  gtk_combo_set_popdown_strings(GTK_COMBO(cmbbox), items);
}


/* This should be fixed, since it translates characters to non-original ones.
 * Perhaps using IPC pipes...
 */
gchar *nt_prepare_msg(gchar *str) 
{
	int i=0;
	while (str[i]) {
		switch(str[i]) {
		case '\'': str[i] = '"'; break;
		case '\n': str[i] = ' '; break;
		}
		i++;
	}	
	return str;
}



/* TODO: Check popen()/pclose() usage
 */
int nt_run_command(gchar *strMsg, gchar *strContact, gchar *strServer)
{
	char cmd[MAX_CFGMSG_LEN+MAX_CFGCONTACT_LEN+MAX_CFGSERVER_LEN+30], *pmsg;
	char buf[MAX_OUTPUT_LEN];
	FILE *outp;
	
	g_printf("Sending \"%s\" to \"%s\" via \"%s\"\n", strMsg, strContact, strServer);
	pmsg = nt_prepare_msg(strMsg);
	if ( !*pmsg )
		return;
	sprintf(cmd, "echo '%s' | %s -name:%s", pmsg, AppCfg.file_bin, strContact);
	if ( !(outp=popen(cmd, "r")) ) {
		perror("nt_run_command");
		return 1;
	}
	while ( fgets(buf, MAX_OUTPUT_LEN, outp) ) {
		if ( !strncmp(buf, "result : ", 9) ) {
			g_printf("nt_run_command is using popen()\n");
			buf[strlen(buf)-1] = '\0';
			sprintf(cmd, "gdialog --msgbox \"%s\" 1 1", (buf+9) );
			system(cmd);
		}
	}
	pclose(outp);
	return 0;
}


gchar *nt_textview_get_text(GtkWidget *text_view)
{
    GtkTextIter start, end;
    GtkTextBuffer *buffer;
    gchar *text;
            
    buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text_view));
    gtk_text_buffer_get_bounds (buffer, &start, &end);
    text = gtk_text_iter_get_text (&start, &end);
    return text;
}


void
nt_message_box                      (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *dialog = gtk_dialog_new();  	
	GtkWidget *contact = lookup_widget(GTK_WIDGET(button), "ceContact");
	GtkWidget *server = lookup_widget(GTK_WIDGET(button), "ceServer");
	GtkWidget *label;
	gchar str[MAX_CFGCONTACT_LEN+MAX_CFGSERVER_LEN+30], *pc;
	
	pc = (gchar *)gtk_entry_get_text(GTK_ENTRY(contact));
	sprintf(str, "\nServer: %s\nContact: %s\nNumero: %d\n", 
		gtk_entry_get_text(GTK_ENTRY(server)),
		pc, ((*pc=='+')||((*pc>='0')&&(*pc<='9')))?1:0);
	label = gtk_label_new(str);

	GtkWidget *okay_button = gtk_button_new_with_label("Oki");

	// Ensure that the dialog box is destroyed when the user clicks ok.
	gtk_signal_connect_object(GTK_OBJECT (okay_button), "clicked", gtk_widget_destroy, GTK_OBJECT(dialog));
	
	// Add the Okay Button to the dialog
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->action_area), okay_button); 	

		
	// Add the label
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), label); 	
	gtk_widget_show_all (dialog);
}



